import java.io.*;
import java.lang.*;

public class BenderProtocol {

    private String tmpversion = "none";
    private String tmpnick 	= "none";
    private String tmpside 	= "none";
    private String tmpcolor 	= "none";

    private	String[] possibletags = { "version", "nick:" , "side:" , "color:" ,"terminates", "status", "say:", "update", "ready", "options","cmd:"};

    public String processInput (String recvline, UserData udatax, String cliid, Values valxx, ActionEventQueue AEQ) {
        boolean knowntag = false;

        // we check for any protocol keywords
        for (int i=0; i <= 10; i++) {
            if (recvline.indexOf(possibletags[i]) >= 0) { knowntag = true; }
        }

        if (!knowntag) { recvline = "PROTOCOL ERROR"; }
        else { recvline = this.createresult(recvline, udatax, cliid, valxx, AEQ); }
        return recvline;
    }




    public String createresult(String rvline, UserData udatay, String cliid, Values valxy, ActionEventQueue AEQ) {

        String status, chat, rvtmp, options, command;

        // check for version
        if ((rvline.indexOf(possibletags[0])) >= 0 ) {
            tmpversion = rvline.substring(8,rvline.length());
            rvtmp = udatay.setUserInfo (udatay, cliid, tmpversion, tmpnick, tmpside, tmpcolor);
            if (rvtmp.equals("")) { rvline = "";}
            else { rvline = rvtmp; }
        }

        // check for nick
        if ((rvline.indexOf(possibletags[1])) >= 0 ) {
            tmpnick = rvline.substring(5,rvline.length());
            if (!udatay.checkNick(cliid, tmpnick))
            { tmpnick = "none"; rvline = "RECHOOSE NICK. NICK GONE ALREADY"; }
            else
            {
                rvtmp = udatay.setUserInfo (udatay, cliid, tmpversion, tmpnick, tmpside, tmpcolor);
                if (rvtmp.equals("")) { rvline = ""; }
                else { rvline = rvtmp; }
            }
        }

        // check for side
        if ((rvline.indexOf(possibletags[2])) >= 0 ) {
            tmpside = rvline.substring(5,rvline.length());
            if ( (tmpside.equals("gdi")) || (tmpside.equals("nod")) ) {
                rvtmp = udatay.setUserInfo (udatay, cliid, tmpversion, tmpnick, tmpside, tmpcolor);
                if (rvtmp.equals("")) { rvline = ""; }
                else { rvline = rvtmp; }
            }
        }

        // check for color
        if ((rvline.indexOf(possibletags[3])) >= 0 ) {
            tmpcolor = rvline.substring(6,rvline.length());
            if (!udatay.checkColor(cliid, tmpcolor))
            { tmpcolor = "none"; rvline = "RECHOOSE COLOR. COLOR GONE ALREDAY"; }
            else
            {
                rvtmp = udatay.setUserInfo (udatay, cliid, tmpversion, tmpnick, tmpside, tmpcolor);
                if (rvtmp.equals("")) { rvline = "LOGIN OK"; }
                else { rvline = rvtmp; }
            }
            udatay.printUserInfo(cliid);
        }

        if ((rvline.indexOf(possibletags[4])) >= 0 ) {
            rvline = "GOOD BYE CLIENT";
        }


        if ((rvline.indexOf(possibletags[5])) >= 0 ) {
            if (rvline.length() < 7) { rvline = "PROTOCOL ERROR"; }
            else {
                status = rvline.substring(7,rvline.length());
                rvline = "STATUS OF " + udatay.printUserInfoToClient(status);
            }
        }

        if ((rvline.indexOf(possibletags[6])) >= 0 ) {
            chat = rvline.substring(4,rvline.length());
            rvline = "CHAT FROM " + cliid + " ::: " + chat;
            udatay.putintoChatBuffer(rvline);
        }

        if ((rvline.indexOf(possibletags[7])) >= 0 ) {
            status = rvline.substring(0,rvline.length());
            rvline = udatay.printServerInfo(cliid, valxy);
        }

        if ((rvline.indexOf(possibletags[8])) >= 0 ) {
            status = rvline.substring(0,rvline.length());
            rvline = udatay.setClientAsReady(cliid, valxy);
        }

        if ((rvline.indexOf(possibletags[9])) >= 0 ) {
            options = rvline.substring(0,rvline.length());
            rvline = udatay.printOptions(valxy);
        }

        if ((rvline.indexOf(possibletags[10])) >= 0 ) {
            command = rvline.substring(4,rvline.length());
            AEQ.addEvent(command, cliid);
            rvline = "";
        }

        return rvline;

    }

}
