#ifndef __ACTIONEVENTQUEUE_H
#define __ACTIONEVENTQUEUE_H

#ifdef _MSC_VER
#pragma warning (disable: 4503)
#pragma warning (disable: 4786)
#endif

#include <queue>
#include <vector>
#include "SDL.h"

/** An abstract class which all actionevents must extend. the run must
 * be implemented. */
class ActionEvent {
public:
    friend class Comp;
    ActionEvent( Uint32 p ) {
        delay = p;
    }
    void addCurtick( Uint32 curtick ) {
        prio=delay+curtick;
    }
    virtual void run() {}// const = 0;





    void setDelay(Uint32 p) {
        delay = p;
    }
    Uint32 getPrio() {
        return prio;
    }
    virtual ~ActionEvent() {}
private:
    Uint32 prio, delay;
};

// Friend class which compares ActionEvents priority
class Comp {
public:
    bool operator()(ActionEvent *x, ActionEvent *y) {
        return x->prio > y->prio;
    }
};

class ActionEventQueue {
public:
    ActionEventQueue();
    ~ActionEventQueue();
    void scheduleEvent(ActionEvent *ev);
    void runEvents();
private:
    Uint32 curtick;
    SDL_TimerID timer;
    std::priority_queue<ActionEvent*, std::vector<ActionEvent*>, Comp> eventqueue;
    static Uint32 timercallback(Uint32 interval, void *param);
};

#endif
