/*****************************************************************************
 * ai.h - header file for AI class
 *
 ****************************************************************************/

#ifndef __AI_H
#define __AI_H

#include <SDL_types.h>

class CnCMap;
class UnitAndStructurePool;
class PlayerPool;
class Player;
class Unit;
class Structure;
class UnitOrStructure;

// changed from 2 for tp2
#define PDBG 7

// attack type
#define ATTACK_WITH_ALL 0x1
#define ATTACK_ONE_ON_ONE 0x2
#define ATTACK_NEAREST 0x4
#define ATTACK_MATCHED_TYPE 0x8
#define DEFAULT_ATTACK ATTACK_WITH_ALL | ATTACK_NEAREST | ATTACK_MATCHED_TYPE
//#define DEFAULT_ATTACK ATTACK_WITH_ALL | ATTACK_ONE_ON_ONE | ATTACK_NEAREST | ATTACK_MATCHED_TYPE

class AI {
public:
    AI(CnCMap *theMap,
       Player *thePlayer);
    ~AI();

    void printAttackType();
    void toggleAttackType(Uint16 theAttackType);
    void attackOtherSide();
    float calcUrgency(UnitOrStructure * const theAU,
                      UnitOrStructure * const theTUOS);
    static void printInfo();
    void lostUnit(Unit *theUnit);
    void lostStructure(Structure *theStructure);
    void lostUnitOrStructure(UnitOrStructure *theUnitOrStructure);
private:
    CnCMap *myMap;
    UnitAndStructurePool *myUASP;
    PlayerPool *myPlayerPool;
    Player *myPlayer;
    Uint16 myAttackType;
    Uint16 myMapWidth;
};

#endif
