/*****************************************************************************
 * game.h - header file for game class
 *
 ****************************************************************************/
#ifndef __GAME_H
#define __GAME_H

#include "graphicsengine.h"
#include "soundengine.h"
#include "input.h"
#include "map.h"
#include "sidebar.h"
#include "cursor.h"
#include "actioneventqueue.h"

class Game {
public:
    Game( GraphicsEngine *gfxengine,
          SoundEngine *sndengine, char *missionname, Uint8 gamenum );
    ~Game();
    void play();
    static int mapscaleq;
private:
    GraphicsEngine *gfxengine;
    SoundEngine *sndengine;
    Input *input;
    CnCMap *map;
    Sidebar *sidebar;
    Cursor *cursor;
    ActionEventQueue *evQueue;
};

#endif
