/*****************************************************************************
 * graphicsengine.h - header file for the GraphicsEngine class
 *
 ****************************************************************************/
#ifndef __GRAPHICSENGINE_H
#define __GRAPHICSENGINE_H

#include "SDL.h"
#include "args.h"
#include "map.h"
#include "sidebar.h"
#include "cursor.h"
#include "imagecache.h"
#include "message.h"

class GraphicsEngine {
public:
    GraphicsEngine(Args *arg);
    ~GraphicsEngine();
    void setupCurrentGame( CnCMap *map, Sidebar *sidebar, Cursor *cursor );
    void renderScene();
    Uint16 getWidth() {
        return width;
    };
    Uint16 getHeight() {
        return height;
    };
    SDL_Rect *getMapArea() {
        return &maparea;
    }
    void drawVQAFrame(SDL_Surface *frame, SDL_Rect *dest);
    void clearScreen();
    void postMessage(char *msg) {
        messages->postMessage(msg);
    }
private:
    void drawSidebar();
    SDL_Surface *screen;
    Uint16 width;
    Uint16 height;
    Uint16 tilewidth;
    SDL_Rect maparea;
    CnCMap *map;
    Sidebar *sidebar;
    Cursor *cursor;
    ImageCache *imgcache;
    MessagePool *messages;
};

class VideoError {}
;

#endif
