/*****************************************************************************
 * inifile.h - header file for inifile
 *
 ****************************************************************************/

#ifndef __INIFILE_H
#define __INIFILE_H

#include "SDL.h"

#include <stdio.h>

#define MAXLINELENGTH 1024
#define MAXSTRINGLENGTH 128
#define INIERROR 0x7fffffff

//#define CONFIGPATH "conf/"
class VFile;
/* For more info on this class see inifile.cpp */

class INIFile {

public:
    INIFile(char *filename);
    ~INIFile();

    char *readString( char *section, char *value );
    char *readString( char *section, char *value, char* deflt );

    int readInt( char* section, char* value, Uint32 deflt);
    int readInt( char* section, char* value );

    char *getLine();

    int seekSection( char *section );

private:

    VFile *inifile;

};



/* Exception to throw */

class INInotFound  {

private:
    char* filename;
public:
    INInotFound(char *f) {
        filename = f;
    };
    const char *getFilename()  {
        return filename;
    };
};

#endif

