#ifndef __MESSAGE_H
#define __MESSAGE_H

#include "SDL.h"
#include <deque>

#include "memtrack.h"

class Font;

class Message {
public:
    Message(char *msg, Uint32 deltime) {
        message = msg;
        this->deltime = deltime;
    }
    ~Message() {
        delete[] message;
    }
    char *getMessage() {
        return message;
    }
    Uint32 getDeleteTime() {
        return deltime;
    }
private:
    char *message;
    Uint32 deltime;
};

class MessagePool {
public:
    MessagePool();
    ~MessagePool();
    SDL_Surface *getMessages();
    void postMessage(char *msg);
    static MessagePool *currentInstance;
private:
    std::deque<Message *> msglist;
    bool updated;
    SDL_Surface *textimg;
    Font *msgfont;
};

#endif
