#ifndef __UNITORSTRUCTURE_H_
#define __UNITORSTRUCTURE_H_
#include "SDL.h"

class Weapon;
class WeaponsPool;
class Unit;
class Structure;

class UnitOrStructureType {
private:
public:
    UnitOrStructureType();
    virtual ~UnitOrStructureType();
    virtual Uint16 getCost() = 0;
    virtual Uint8 getSpeed() = 0;
    virtual Uint8 getTurnspeed() = 0;
    virtual Uint8 getSight() = 0;
    virtual Uint8 getArmour() = 0;
    virtual Uint8 getNumLayers() = 0;
    virtual Weapon* getWeapon(bool primary) = 0;
    virtual bool isInfantry() = 0;
    virtual bool isWall() = 0;
};

class UnitOrStructure {
private:
public:
    UnitOrStructure();
    virtual ~UnitOrStructure();
    virtual Sint16 getXoffset() = 0;
    virtual Sint16 getYoffset() = 0;
    virtual Uint16 getHealth() = 0;
    virtual Uint8 getOwner() = 0;
    virtual void setOwner(Uint8) = 0;
    virtual Uint16 getPos() = 0;
    virtual Uint16 getSubpos() = 0;
    virtual Uint16 getBPos() = 0;
    virtual UnitOrStructureType* getType() = 0;
    virtual Uint32 getImageNum(Uint8 layer) = 0;
    virtual void referTo() = 0;
    virtual void unrefer() = 0;
    virtual void remove() = 0;
    virtual bool isAlive() = 0;
    virtual void select() = 0;
    virtual void unSelect() = 0;
    virtual bool isSelected() = 0;
    virtual void attackUnit(Unit* un) = 0;
    virtual void attackStructure(Structure* str) = 0;
    virtual void attackUnitOrStructure(UnitOrStructure* uos) = 0;
    virtual void applyDamage(Sint16 amount, Weapon* weap) = 0;
    virtual double getRatio() = 0;
};
#endif /* __UNITORSTRUCTURE_H_ */
