#include "cursorpool.h"
#include "inifile.h"
#include "memtrack.h"

CursorPool::CursorPool(char* ininame) {
    if (ininame == NULL) {
        return;
    }
    cursorini = new INIFile(ininame);
    if (cursorini == NULL) {
        return;
    }
}

CursorPool::~CursorPool() {
    delete cursorini;
    for (Uint32 i = 0; i < cursorpool.size(); ++i) {
        delete cursorpool[i];
    }
}

cursorinfo* CursorPool::getCursorByName(char* name) {
    map<string, Uint16>::iterator cursorentry;
    cursorinfo* datum;
    Uint16 index;

    cursorentry = name2index.find((string)name);
    if (cursorentry != name2index.end() ) {
        index = cursorentry->second;
        datum = cursorpool[index];
    } else {
        index = cursorpool.size();
        datum = new cursorinfo;
        cursorini->seekSection(name);
        datum->anstart = cursorini->readInt(name,"start",0);
        datum->anend = cursorini->readInt(name,"end",0);
        cursorpool.push_back(datum);
        name2index[(string)name] = index;
    }

    return datum;
}
